SystemOrganization addCategory: #'Pier-Setup'!

Object subclass: #PRDistribution
	instanceVariableNames: 'blog contentsWidget environmentPage metaEnvironmentPage breadcrumbWidget commandsPage googleAnalyticsWidget siteTitlePage sitemapPage stylesheetFile systemManagementPage viewsPage menuWidget loginCommandWidget mainEnvironmentPage childrenWidget postTickerWidget rootPage kernel syntaxPage aboutPage blogArchiveWidget blogEnvironmentPage poweredByPage searchWidget headerPage footerPage shortcutsPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Setup'!

!PRDistribution class methodsFor: 'as yet unclassified' stamp: 'tg 9/12/2008 14:41'!
workspaceText

	^
'"----------PIER-----------
Pier is already running at:
http://localhost:8080/seaside/pier

The Seaside server administration interface can be reached at: 
http://localhost:8080/seaside/config

The default username/password for both Pier and Seaside is admin/pier.

For more information about Pier check:
http://www.piercms.com
-------------------------"

"Web server management"
WAKomEncoded startOn: 8080.
WAKomEncoded stop.

"Memory cleanup"
WARegistry clearAllHandlers.
MCFileBasedRepository flushAllCaches.
Smalltalk garbageCollect.

"In memory persistency (default)"
PRKernel instances anyOne persistency: PRNullPersistency new.

"Image persistency (save up to 3 images and in 30 mins after a change)"
PRKernel instances anyOne persistency: (PRImagePersistency new 
											duration: 30 minutes;
											maxImages: 3).
			
"Reset all Pier settings to the original ones"
PRDistribution new register.

"Useful shortcuts"
PRKernel instances anyOne root.'! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/17/2008 09:18'!
aboutPage
	^ aboutPage ifNil: [
		aboutPage := (PRPage named: 'about')
					title: 'About Pier';
					contents:
'*Pier>http://www.piercms.com* is a content management system that aims at allowing users to manage their content from the browser.

The central concept in Pier is the one of Structure. For example, the current page is a structure. The */blog* is also a structure, but it is slightly different than a page. A file is also a structure.

Commands can be executed on a Structure. For example, a Structure can be edited. In the current setup you can edit this site after logging in (the commands appear in the footer). Once in edit mode, you can use the *syntax*. To make life easier, Pier also offers access to these commands via *shortcuts*.

Any Structure can be Viewed. The default View is the one that renders the structure for normal usage. Another example, is the Browse View which offers a file system like view on the Pier structures.

Any Structure has an environment which defines the template. For example, the environment of this page is */environment* (you have to be logged in to see it). To set the environment to be a different page use the Settings command. To edit the environment use the Edit Design command.

A Structure can contain Widgets. For example, the environment of this page contains a menu widget on top, and a widget that enumerates the children of the current sturcture to the right.

More about Pier can be found at: *http://www.piercms.com*.'
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/17/2008 00:15'!
blog
	^ blog ifNil: [
		blog := (PBBlog named: 'blog')
		addChild: (
			(PBPost named: 'downtobusiness')
			title: 'Down to business';
			contents: 'I like blogging, so here is my second post.';
			publication: TimeStamp now;
			addChild: ((PBComment named: '1')
				contents: 'We are glad to see that you get serious about blogging. Btw, this is a comment.';
				author: 'The Pier Team';
				website: 'http://www.piercms.com';
				yourself
				);
			yourself
		);
		addChild: (
			(PBPost named: 'hello')
			title: 'Hello';
			contents: 'Hi!! This is my first post.';
			publication: TimeStamp today;
			yourself
		);
		yourself
	].
! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/13/2008 19:00'!
blogArchiveWidget
	^ blogArchiveWidget ifNil: [
		blogArchiveWidget := (PRComponent named: 'blogarchive')
		title: 'Blog Archive';
		componentClass: PBPostArchive;
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/17/2008 09:25'!
blogEnvironmentPage
	^ blogEnvironmentPage ifNil: [
		blogEnvironmentPage := (PRPage named: 'blogenvironment')
		title: '_Blog Environment';
		contents: 
'<div class="container">
	+/environment/header+
	<div class="column span-24 last mainbody">
		<div class="column span-12 contents">+/environment/contents+</div>
		<div class="column span-6 prepend-6 last navigation">
!!!!Archive
			+/environment/blogarchive+
		</div>
	</div>
	+/environment/footer+
</div>
+/environment/googleanalytics+
';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:24'!
breadcrumbWidget
	^ breadcrumbWidget ifNil: [breadcrumbWidget := (PRComponent named: 'breadcrumb')
		componentClass: PRBreadcrumbWidget;
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:25'!
childrenWidget
	^ childrenWidget ifNil: [childrenWidget := (PRComponent named: 'children')
		componentClass: PRChildrenWidget;
		write: 2
			using: PRChildrenWidget descriptionLevel;
		write: true
			using: PRChildrenWidget descriptionExpand;
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/13/2008 19:01'!
commandsPage
	^ commandsPage ifNil: [
		commandsPage := (PRPage named: 'commands') 
		addChild: ((PRComponent named: 'widget') componentClass: PRCommandsWidget; yourself);
		contents: 'Commands: +widget+';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:26'!
contentsWidget
	^ contentsWidget ifNil: [
		contentsWidget := (PRComponent named: 'contents')
		componentClass: PRContentsWidget;
		write: '%c' using: PRContentsWidget descriptionHeading;
		yourself
	].! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/17/2008 00:46'!
environmentPage
	^ environmentPage ifNil: [
		environmentPage := (PRPage named: 'environment')
		title: '_Environment';
		contents: 
'<div class="container">
	+/environment/header+
	<div class="column span-24 last mainbody">
		<div class="column span-12 contents">+/environment/contents+</div>
		<div class="column span-6 prepend-6 last navigation">
!!!!Navigation
			+/environment/children+
		</div>
	</div>
	+/environment/footer+
</div>
+/environment/googleanalytics+
';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/17/2008 00:46'!
footerPage
	^ footerPage ifNil: [
		footerPage := (PRPage named: 'footer')
		contents:
'<div class="footer column span-24 last">
	<div class="column span-20">
		+/environment/justlogincommand+
		<div class="commands">+/environment/commands+</div>
		<div class="views">+/environment/views+</div>
		<div class="sitemap">+/environment/sitemap+</div>
	</div>
	<div class="column span-4 right last">+/environment/poweredby+</div>
</div>
';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:27'!
googleAnalyticsWidget
	^ googleAnalyticsWidget ifNil: [ 
		googleAnalyticsWidget := (PRComponent named: 'googleanalytics')
		title: 'Google Analytics';
		componentClass: PRGoogleAnalyticsWidget
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/17/2008 00:47'!
headerPage
	^ headerPage ifNil: [
		headerPage := (PRPage named: 'header')
		contents:
'<div class="column span-24 last header">
	<div class="column span-18 title">+/environment/sitetitle+</div>
	<div class="column span-6 last search">+/environment/search+</div>
	<div class="column span-24 last menu">+/environment/menu+</div>
</div>';
		yourself
	]! !

!PRDistribution methodsFor: 'creation' stamp: 'tg 9/6/2008 18:46'!
kernel
	^ kernel ifNil: [
		kernel := PRKernel named: 'pier'.
		kernel root: self root.
		kernel
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/8/2008 15:58'!
loginCommandWidget
	^ loginCommandWidget ifNil: [
		loginCommandWidget := (PRComponent named: 'justlogincommand')
		title: 'Just Login Command';
		componentClass: PRCommandsWidget;
		write: (Array with: PULogin) using: PRCommandsWidget descriptionCommandClasses ;
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/17/2008 00:48'!
mainEnvironmentPage
	^ mainEnvironmentPage ifNil: [
		mainEnvironmentPage := (PRPage named: 'mainenvironment')
		title: '_Main Environment';
		contents: 
'<div class="container">
	+/environment/header+
	<div class="column span-24 last mainbody">
		<div class="contents column span-12">+/environment/contents+</div>
		<div class="postticker column prepend-6 span-6 last">
!!!!What''s new
			+/environment/postticker+
		</div>
	</div>
	+/environment/footer+
</div>
+/environment/googleanalytics+
';
		yourself
	]! !

!PRDistribution methodsFor: 'rights' stamp: 'tg 9/5/2008 22:52'!
makePrivate: aStructure

	aStructure securityDecoration owner: self kernel users anyOne.
	aStructure securityDecoration otherPermissions: Set new.
	aStructure securityDecoration group: self kernel groups anyOne.
! !

!PRDistribution methodsFor: 'rights' stamp: 'tg 9/5/2008 22:59'!
makePublic: aStructure

	aStructure securityDecoration owner: self kernel users anyOne.
	aStructure securityDecoration otherPermissions: Set new.
	aStructure securityDecoration group: self kernel groups anyOne.
! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/13/2008 19:02'!
menuWidget
	^ menuWidget ifNil: [
		menuWidget := (PRComponent named: 'menu')
		componentClass: PRMenuWidget;
		write: (PRDocumentParser parse: '- *Home>/*
- *Blog>/blog*
- *About>/about*') using: PRMenuWidget descriptionDocument;
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:29'!
metaEnvironmentPage
	^ metaEnvironmentPage ifNil: [
		metaEnvironmentPage := (PRPage named: 'metaenvironment')
		title: '_Meta Environment';
		hideFromMenus: true;
		contents: '<div class="container metaenvironment">
	<div class="span-24 last metaheader">
		Meta page: +/environment/breadcrumb+
	</div>
	<div class="span-24 last">
		+/environment/contents+
	</div>
	<div class="span-24 last metafooter">
		<div class="span-10">+/environment/commands+</div>
		<div class="span-10 last">+/environment/sitemap+</div>
	</div>

</div>';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:30'!
postTickerWidget
	^ postTickerWidget ifNil: [
		postTickerWidget := (PRComponent named: 'postticker')
		title: 'Post Ticker';
		componentClass: PBPostTicker;
		write: blog using: PBPostTicker descriptionBlog;
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/13/2008 14:42'!
poweredPage
	^ poweredByPage ifNil: [poweredByPage := (PRPage named: 'poweredby')
		title: 'Powered By';
		contents: 
'Powered by *Pier>http://www.piercms.com*';
		yourself
	]! !

!PRDistribution methodsFor: 'creation' stamp: 'tg 9/9/2008 00:58'!
register 
	PRKernel reset.
	PRPierFrame 
		registerAsApplication: 'pier'
		kernel: self kernel! !

!PRDistribution methodsFor: 'creation' stamp: 'tg 9/17/2008 09:19'!
root
	self rootPage
		addChild: (self blog
				addChild: self blogArchiveWidget;
				yourself);
		addChild: (self aboutPage
				addChild: self syntaxPage;
				addChild: self shortcutsPage;
				yourself);
		addChild: (self environmentPage
				addChild: self headerPage;
				addChild: self siteTitlePage;
				addChild: self footerPage;
				addChild: self menuWidget;
				addChild: self childrenWidget;
				addChild: self breadcrumbWidget;
				addChild: self googleAnalyticsWidget;
				addChild: self sitemapPage;
				addChild: self viewsPage;
				addChild: self commandsPage;
				addChild: self loginCommandWidget;
				addChild: self contentsWidget;
				addChild: self stylesheetFile;
				addChild: self systemManagementPage;
				addChild: self postTickerWidget;
				addChild: self blogArchiveWidget;
				addChild: self searchWidget;
				addChild: self poweredPage;
				yourself);
		addChild: self blogEnvironmentPage;
		addChild: self mainEnvironmentPage;
		addChild: self metaEnvironmentPage.
	self rootPage localEnvironment: self mainEnvironmentPage.
	self blog localEnvironment: self blogEnvironmentPage.
	self aboutPage localEnvironment: self environmentPage.
	self environmentPage localEnvironment: self metaEnvironmentPage.
	self mainEnvironmentPage localEnvironment: self metaEnvironmentPage.
	self metaEnvironmentPage localEnvironment: self metaEnvironmentPage.
	self rootPage localStyleSheet: self stylesheetFile.
	self rootPage enumerator
		with;
		all;
		do: 
			[ :each | 
			each securityDecoration owner: self kernel users anyOne.
			each securityDecoration group: self kernel groups anyOne ].
	self makePrivate: self environmentPage.
	self makePrivate: self blogEnvironmentPage.
	self makePrivate: self mainEnvironmentPage.
	self makePrivate: self metaEnvironmentPage.
	self makePrivate: self sitemapPage.
	self makePrivate: self viewsPage.
	self makePrivate: self commandsPage.
	self makePrivate: self systemManagementPage.
	^ self rootPage! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/17/2008 00:45'!
rootPage
	^ rootPage ifNil: [
		rootPage := (PRPage named: 'pier')
		title: 'Welcome to Pier!!';
		contents:
'This is the main page of the official Pier distribution. Before you can modify this site, you have to login using: admin/pier.

Have fun,<br></br>
The Pier Team
';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/17/2008 09:13'!
searchWidget
	^ searchWidget ifNil: [
		searchWidget := (PRComponent named: 'search')
		componentClass: PRAjaxSearchWidget;
		write: ( PRStructure withAllConcreteClasses reject: [:each | each = PRPage or: [each = PBPost]] ) using: PRAjaxSearchWidget descriptionFilter ;
		yourself
	].! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/17/2008 09:20'!
shortcutsPage
	^ shortcutsPage ifNil: 
		[ shortcutsPage := (PRPage named: 'shortcuts')
			title: 'Pier keyboard shortcuts';
			contents: 'You can manage Pier using keyboard shortcuts. The following work at least on Firefox and Safari on Mac OS X:
- Ctrl\+e = Edit
- Ctrl\+l = Login/Logout
- Ctrl\+a = Add
- Ctrl\+r = Remove
- Ctrl\+m = Move
- Ctrl\+t = Settings
- Ctrl\+c = Copy
- Ctrl\+d = Edit Design' ]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/17/2008 00:11'!
siteTitlePage
	^ siteTitlePage ifNil: [
		siteTitlePage := (PRPage named: 'sitetitle')
		title: 'Site Title';
		contents: '!!*Your Pier>/*';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/13/2008 19:02'!
sitemapPage
	^ sitemapPage ifNil: [
		sitemapPage := (PRPage named: 'sitemap')
		addChild: ((PRComponent named: 'widget')
				componentClass: PRTreeWidget;
				yourself);
		contents:
'Sitemap
+widget+'
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/22/2008 22:50'!
stylesheetFile
	^ stylesheetFile ifNil: [
		stylesheetFile := (PRFile named: 'css')
		mimetype: 'text/css';
		contents: 
'h1, h2, h3, h4, h5, h6 { margin: 0; font-weight: inherit; font-size: 100%; line-height: auto; }
h1.heading {font-size:3em;line-height:1;margin-bottom:0.5em;}
h1 { font-size: 2em; margin-bottom: 0.75em; }
h2 { font-size: 1.5em; line-height: 1; margin-bottom: 1em; }
h3 { font-size: 1.2em; height: 1.25em; line-height: 1.25; margin-bottom: 1.25em; }
h4 { font-size: 1em; font-weight: bold; margin-bottom: 1.5em; }
h5 { font-size: 1em; font-weight: bold; }
h6 { font-size: 1em; }
textarea {width: 100%;}

/* PIER */
.broken { color: red; }
.protected { color: #aaa; }
a:hover {background: #333; color: #ff6633;}
a {color: #ff6633;}
a.view, a.command {color: gray;}
a {text-decoration: none;}
a.environment:after {content: "*";}
.right {text-align: right;}
.center {text-align: center;}
.float {float: right;}
th {background: #ddd;}

/* HEADER */
.header .title h1 a {
	font-size: 140%;
	outline: none;
	display: block;
	color: #333;
	background: white;
}
.header .search {text-align: right;}
.header .search input {
	outline: none;
	width: 223px;
	padding-right: 0;
	margin-top: 0;}
.header .search ul {
	margin: 0;
	padding: 0;
	background: #fff;
	list-style-type: none;
	border: 1px solid #aaa;
	border-top: none;}
.header .search li.selected {
	background-color: #333;}
.header .search li {
	margin: 0;
	display: block;
	padding: 0.2em;
	cursor: pointer;
	list-style-type: none;}
.header .search a {
	text-decoration: none;}
.header .search li.selected a {color: #fff;}
.menu {
	font-size: 120%;
	line-height: 120%;
	background: #333;}
.menu ul {
	margin: 0;
	padding-top: 1em;
	padding-bottom: 0.5em;
	list-style-type: none;}
.menu ul li {
	display: inline;
	margin: 0;
	margin-left: 5px;
	margin-right: 10px;
	list-style-type: none;}
.menu li a {
	color: white;
	padding-top: 1em;
	padding-bottom: 0.5em;
	padding-left: 10px;
	padding-right: 10px;}
.menu li a.active {
	padding-top: 1.1em; /*THIS IS A HACK*/
	background: white;
	color: #333;}
.menu li a:hover {
	background: #aaa;
	color: #333;}

/* NAVIGATION */
.navigation ul {
	margin-top: 0;
	margin-left: 0;
	list-style-type: none;}
.navigation ul ul {
	margin-bottom: 0;
	margin-left: 1.5em;}
.navigation .active {
	font-weight: bold;}

/*MAIN BODY*/
.mainbody {
	padding-top: 2em;
	padding-bottom: 10em;}
.postticker ul {
	list-style: none;
	margin-left: 0;}
.postticker ul li {
	margin-bottom: 1.5em;}
.postticker .timestamp {color: #aaa; font-size: 80%;}
.postticker .timestamp .time {display: none;}
.meta {font-size: 80%; color: #aaa;}
.post {margin-bottom: 3em;}
.leavecomment {margin-top: 3em; margin-bottom: 3em;}
.comments {margin-top: 3em;}

/* FOOTER */
.footer {
	color: #aaa;
	font-size: 80%;
	text-align: left;
	border-top: 1px solid #333;}
.footer ul {list-style: none; margin-left: 0em;}
.footer ul ul {margin-left: 1.5em;}
.footer .commands ul, .footer .views ul {display: inline;}
.footer .commands ul li, .footer .views ul li {display: inline; padding-right: 1em;}

/* META */
.metaenvironment h1.heading {display: none;}
.metaheader {background: #C3D9FF; font-size: 200%}
.metaheader ul {display: inline; margin: 0;}
.metaheader li {list-style: none; display: inline; margin: 0;}
.metaheader li:after {content: "/"}
.metaenvironment.container {border: 1px solid #C3D9FF; margin-top: 0;}
.metafooter {background: #C3D9FF;}
.metafooter li {list-style: none;}
';
		yourself]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/12/2008 23:08'!
syntaxPage
	^ syntaxPage ifNil: [
		syntaxPage := (PRPage named: 'syntax')
		title: 'Pier syntax';
		contents: '!!Paragraphs
A single newline has no effect on the layout. An empty line starts a new paragraph.

!!Sections
A line starting with ==!!== becomes a section heading. Use multiple ==!!== to create a subsection. Don''t skip levels. The software can automatically generate a table of contents from headings. 

!!Horizontal Line
A line starting with ==_== (underline) becomes a horizontal line. This is often used to separate topics.

!!Lists
Lines starting with ==#==, ==-==, ==;== or ==:== create a list:
-A block of lines, where each line starts with ==-== is transformed to a bulleted list, where each line is an entry.
-A block of lines, where each line starts with ==#== is transformed to an ordered list, where each line is an entry.
-A block of lines, where each line starts with ==;== or ==:== is transformed to a definition list, where the keyword is prepended with ==;== and the definition with ==:==. Keywords and definitions can be mixed arbitrary.
Lists can be nested. Thus, a line starting with ==#-== is an element of a bulleted list that is part of an ordered list.

!!Tables
To create a table, start off the lines with ==|== and separate the elements with ==|==s. Each new line represents a new row of the table. The contents of cells can be aligned left, centered or aligned right by using ==|{==, ==||== or ==|}== respectively. Adding a single ==!!== to a table cell becomes a table heading.

!!Preformatted
To create a preformatted section, begin each line with =====. A preformatted section uses equally spaced text so that spacing is preserved.

!!Links
To create a link, put it between ==\*==. All links have the following form ==\*reference\*== or ==\*alias>reference\*==, where the reference is depending on the kind of link that is created. The contents of some links, e.g. links pointing to image-files, downloads or other pages, can be embedded into the current document by putting the reference between ==\+==, for example ==\+reference\+==. Not all types of links support embedding and quietly ignore it.

!!!!Internal Links
If a structure with the given name exists, a link to that item shows up when the page is saved. In case the path points to an non-existing structure, the user will be offered the possibility to create a new one when clicking on the link. The reference can be any absolute (==/license==) or relative (==../license==) path.

!!!!External Links
-If the link is an URL (e.g. ==\*http://www.lukas-renggli.ch\*==), a link to the external page shows up.
-If the link is an e-mail address (e.g. ==\*renggli@gmail.com\*==), a link to mail that person shows up.
-If the link is an ISBN number (e.g. ==\*isbn:3446202102\*==), a link to the given book shows up.
-If the link is an RFC number (e.g. ==\*rfc:2616\*==), a link to the given RFC page shows up.

!!Formatting
There is some sugar for basic font formattings:
-To make something ""bold"", surround it with ==\""==
-To make something ''''italic'''', surround it with ==\''''==
-To make something ==monospaced==, surround it with ==\====
-To make something --strikethrough--, surround it with ==\--==
-To make something @@subscript@@, surround it with ==\@@==
-To make something ^^superscript^^, surround it with ==\^^==
-To make something __underlined__, surround it with ==\__==';
		yourself
	].! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:33'!
systemManagementPage
	^ systemManagementPage ifNil: [
		systemManagementPage := (PRPage named: 'systemmanagement')
		title: '_System Management';
		addChild: ((PRComponent named: 'users')
				componentClass: PUUsersWidget;
				yourself);
		addChild: ((PRComponent named: 'groups')
				componentClass: PUGroupsWidget;
				yourself);
		addChild: ((PRComponent named: 'persistency')
				componentClass: PRPersistencySettings;
				yourself);
		addChild: ((PRComponent named: 'kernel')
				componentClass: PRKernelSettings;
				yourself);
		contents: '!!Users
+users+

!!User Group
+groups+

!!Persistency
+persistency+

!!Pier Kernel Settings
+kernel+

';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:33'!
viewsPage
	^ viewsPage ifNil: [
		viewsPage := (PRPage named: 'views')
		addChild: ((PRComponent named: 'widget')
				componentClass: PRViewsWidget;
				yourself);
		contents: 'Views: +widget+'
	]! !
